#ifndef BOUNDCURVE_H
#define BOUNDCURVE_H
# include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <float.h>
#include <limits.h>
#include <stdlib.h>

class boundcurves
{
 public:
  boundcurves(long tnbn,long *multip,long **cnbn,long *coarseidentif,long *coarsenadjac,long **coarseadjac,FILE *outfil);
  ~boundcurves();
  
  void reduce_graph();
  void set_curves();
  void set_curves_3D( );
  long compute_number_of_combination(long n, long k);
  void print_info();
  void add_corners(long condcorner,long typecondcorner,long nmember,long intpointo);
  void add_rand(long nmember);
  void add_each_nth_member(long nmember);
  void add_nth_member(long nmember);
  void add_all_members( );
  void add_centroid();
  void add_intpoint(long intpointo);
  void add_n_part_curve(long nmember);
  void get_coarseidentif(long *coarseidentif);
  
  FILE *out;
  long ncn;
  long *multiplicity;
  long **cnbn;
  long *identif;
  long *nadjacnod;
  long **adjacnod;
  
  // number of curves
  long ncurves;
  // list of start nodes of curves
  long *start;
  // list of end nodes of curves
  long *end;
  // list of members of curves
  long **members;
  // 
  long *nmembers;
  //
  long *nedges;
  
  // number of subdomain where the curves lies
  long *ndomid;
  // 
  long **domid;

  // corespondence between coarse numbers of members of curves
  long ***memcor;

  //reduce flag
  long reduce_flag;
  long *reducecor;
  long *correduce;

};

#endif
