#ifndef PGALIAS_H
#define PGALIAS_H
#include "../GEFEL/kwdset.h"

//  aliases for type of domain decomposition method
enum domdectype {schurcompldd=1,fetidd=5,dpfetidd=10,parconjuggrad=40,boundparconjuggrad=45,layered_plate=50};
const enumstr domdectypestr[6] = {{"schurcompldd",1}, {"fetidd",5}, {"dpfetidd",10}, {"parconjuggrad",40},{"boundparconjuggrad",45},  {"layered_plate",50}};
const kwdset domdectype_kwdset(sizeof(domdectypestr)/sizeof(*domdectypestr), domdectypestr);

//  aliases for type of preconditioner of FETI method
enum fetiprecond {nofetiprecond=0,lumped=1,dirichlet=2};
const enumstr fetiprecondstr[3] = {{"nofetiprecond",0},{"lumped",1}, {"dirichlet",2}};
const kwdset fetiprecond_kwdset(sizeof(fetiprecondstr)/sizeof(*fetiprecondstr),fetiprecondstr);

// aliases for condensation of corner node in FETI-DP method
enum condcorner {nocondconer=0,automatic=1,userdef=2};
const enumstr condcornerstr[3] = {{"nocondcorner",0},{"automatic",1}, {"userdef",2}};
const kwdset condcorner_kwdset(sizeof(condcornerstr)/sizeof(*condcornerstr),condcornerstr);

// aliases for type automatic and user defined condensation of corner node in FETI-DP method
enum typecondcorner {nocondcorner=0,centroid=1,inflex=2,each_nth_memb=3,nth_memb=4,all_memb=5,rand_memb=6,int_memb=7,n_part_curve=8,multipstat=9};
const enumstr typecondcornerstr[10] = {{"nocondcorner",0},{"centroid",1},{"inflex",2},{"each_nth_memb",3},{"nth_memb",4},{"all_memb",5},{"rand_memb",6},{"int_memb",7},{"n_part_curve",8},{"multipstat",9}}; 
const kwdset typecondcorner_kwdset(sizeof(typecondcornerstr)/sizeof(*typecondcornerstr),typecondcornerstr);

//  aliases for type of preconditioner of parallel conjugate gradient method
enum parcgprec {noprec=0,petscilu=1,pardiagprec=2};
const enumstr parcgprecstr[3] = {{"noprec",0},{"petscilu",1},{"pardiagprec",2}};
const kwdset parcgprec_kwdset(sizeof(parcgprecstr)/sizeof(*parcgprecstr),parcgprecstr);
#endif
